variables:
  IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH:$CI_BUILD_REF_NAME
  DEV_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH:develop
  HUB_IMAGE: monachus/wordpress
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375/

image: docker:stable

services:
  - docker:dind

before_script:
  - docker info
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY

build:
  stage: build
  script:
    - docker pull $DEV_IMAGE || true
    - docker build --cache-from $DEV_IMAGE -t $IMAGE .
    - docker push $IMAGE
  except:
    - master

push_to_docker_hub:
  stage: deploy
  script:
    - docker login -u $HUB_USERNAME -p $HUB_PASSWORD
    - docker pull $IMAGE
    - docker tag $IMAGE $HUB_IMAGE:$CI_BUILD_REF_NAME
    - docker tag $IMAGE $HUB_IMAGE:latest
    - docker push $HUB_IMAGE:$CI_BUILD_REF_NAME
    - docker push $HUB_IMAGE:latest
  only:
    - tags
